package com.huimv.environ.server;

import com.huimv.environ.dao.entity.EnvHourEntity;
import com.huimv.environ.dao.entity.EnvMinuteEntity;
import com.huimv.environ.dao.entity.EnvRealTimeEntity;
import com.huimv.environ.dao.repo.EnvHourRepo;
import com.huimv.environ.dao.repo.EnvMinuteRepo;
import com.huimv.environ.dao.repo.EnvRealTimeRepo;
import com.huimv.environ.utils.DateUtil;
import io.netty.buffer.ByteBuf;
import io.netty.buffer.Unpooled;
import io.netty.channel.ChannelFutureListener;
import io.netty.channel.ChannelHandler.Sharable;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.ChannelInboundHandlerAdapter;
import io.netty.util.CharsetUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.sql.Timestamp;
import java.text.ParseException;
import java.util.Date;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/

@Sharable
@Component
public class EnvironServerHandler extends ChannelInboundHandlerAdapter{
    @Autowired
    private EnvironDataHandler environDataHandler;
    @Override
    public void channelRead(ChannelHandlerContext ctx, Object msg) throws Exception {
        //将客户端传入的消息转换为Netty的ByteBuf类型
        ByteBuf in = (ByteBuf) msg;
        String receive = in.toString(CharsetUtil.UTF_8);

        // 在控制台打印传入的消息
//        System.out.println(
//                "Server received: " + in.toString(CharsetUtil.UTF_8)
//        );
//        System.out.println("接收到数据>>"+receive);
        //处理接收环保实时数据
//
//        EnvironDataHandler environDataHandler = new EnvironDataHandler();
        environDataHandler.handleReceiveData(receive);
//        handleReceiveData(receive);

        //将接收到的消息写给发送者，而不冲刷出站消息 (应答)
//        ctx.write(in);
    }

    @Override
    public void channelReadComplete(ChannelHandlerContext ctx) throws Exception {
        // 将未处决消息冲刷到远程节点， 并且关闭该Channel
        ctx.writeAndFlush(Unpooled.EMPTY_BUFFER)
                .addListener(ChannelFutureListener.CLOSE);
    }

    /**
     * 异常处理
     * @param ctx
     * @param cause
     * @throws Exception
     */
    @Override
    public void exceptionCaught(ChannelHandlerContext ctx, Throwable cause) throws Exception {
        //打印异常栈跟踪
        cause.printStackTrace();

        // 关闭该Channel
        ctx.close();
    }

//    //
//    public void handleReceiveData(String receiveData) throws ParseException {
//        System.out.println("开始解析数据");
//        DateUtil dateUtil = new DateUtil();
//        String[] receiveDataArray = receiveData.split(";");
////        System.out.println("receiveDataArray="+receiveDataArray.length);
//        for(int a=0;a<receiveDataArray.length;a++){
//            System.out.println(a+" "+receiveDataArray[a]);
//        }
//        System.out.println();
//        String stText = receiveDataArray[1];
//        if(stText.indexOf("ST=") != -1){
//            String st = stText.substring(stText.indexOf("ST=")+3,stText.length());
//            if(st.trim().equalsIgnoreCase("32")){
//                String cnText = receiveDataArray[2];
//                if(cnText.indexOf("CN=") != -1){
//                    String cn = cnText.substring(cnText.indexOf("CN=")+3,cnText.length());
//                    System.out.println(""+cn);
//                    if(cn.trim().equalsIgnoreCase("2011"))
//                    {
//                        //实时采样数据
//                        System.out.println("实时");
//                        EnvRealTimeEntity envRealTimeEntity = new EnvRealTimeEntity();
//                        envRealTimeEntity.setSt(st);
//                        envRealTimeEntity.setCn(cn);
//                        //qn
//                        String qnText = receiveDataArray[0];
//                        String qn = qnText.substring(qnText.indexOf("QN=")+3,qnText.length());
//                        System.out.println("qn>>"+qn);
//                        envRealTimeEntity.setQn(qn);
//                        //mn
//                        String mnText = receiveDataArray[4];
//                        String mn = mnText.substring(mnText.indexOf("MN=")+3,mnText.length());
//                        System.out.println("mn>>"+mn);
//                        envRealTimeEntity.setMn(mn);
//                        //flag
////                        String flagText = receiveDataArray[5];
////                        String flag = flagText.substring(flagText.indexOf("Flag=")+5,flagText.length());
////                        System.out.println("flag>>"+flag);
//                        //datetime
//                        String datetimeText = receiveDataArray[6];
//                        String datetime = datetimeText.substring(datetimeText.indexOf("DataTime=")+9,datetimeText.length());
//                        System.out.println("datetime>>"+datetime+" "+dateUtil.parseDateTime(dateUtil.rebuildDateTime(datetime)));
//                        envRealTimeEntity.setDatetime(new Timestamp(dateUtil.parseDateTimeLong(dateUtil.rebuildDateTime(datetime))));
//                        //w01018
//                        String w01018Text = receiveDataArray[7];
//                        String[] w01018TextArray = w01018Text.split(",");
//                        //value1
//                        String  w01018TextData = w01018TextArray[0];
//                        String[] w01018TextDataArray = w01018TextData.split("=");
//                        String value1 = w01018TextDataArray[1];
//                        envRealTimeEntity.setHxxyl(value1);
//                        //flag1
//                        String  w01018TextFlag = w01018TextArray[1];
//                        String[] w01018TextFlagArray = w01018TextFlag.split("=");
//                        String state1 = w01018TextFlagArray[1];
//                        envRealTimeEntity.setHxxylzt(state1);
////                        System.out.println(value1+","+state1);
//
//                        //w21003
//                        String w21003Text = receiveDataArray[8];
//                        String[] w21003TextArray = w21003Text.split(",");
//                        //value
//                        String  w21003TextData = w21003TextArray[0];
//                        String[] w21003TextDataArray = w21003TextData.split("=");
//                        String value2 = w21003TextDataArray[1];
//                        envRealTimeEntity.setAd(value2);
//                        //flag
//                        String  w21003TextFlag = w21003TextArray[1];
//                        String[] w21003TextFlagArray = w21003TextFlag.split("=");
//                        String state2 = w21003TextFlagArray[1];
//                        envRealTimeEntity.setAdzt(state2);
//                        System.out.println(value2+","+state2);
//
//                        //w01001
//                        String w01001Text = receiveDataArray[9];
//                        String[] w01001TextArray = w01001Text.split(",");
//                        //value
//                        String  w01001TextData = w01001TextArray[0];
//                        String[] w01001TextDataArray = w01001TextData.split("=");
//                        String value3 = w01001TextDataArray[1];
//                        envRealTimeEntity.setPh(value3);
//                        //flag
//                        String  w01001TextFlag = w01001TextArray[1];
//                        String[] w01001TextFlagArray = w01001TextFlag.split("=");
//                        String state3 = w01001TextFlagArray[1];
//                        envRealTimeEntity.setPhzt(state3);
////                        System.out.println(value3+","+state3);
//
//                        //w00000
//                        String w00000Text = receiveDataArray[10];
//                        String[] w00000TextArray = w00000Text.split(",");
//                        //value
//                        String  w00000TextData = w00000TextArray[0];
//                        String[] w00000TextDataArray = w00000TextData.split("=");
//                        String value4 = w00000TextDataArray[1];
//                        envRealTimeEntity.setWs(value4);
//                        //flag
//                        String  w00000TextFlag = w00000TextArray[1];
//                        String[] w00000TextFlagArray = w00000TextFlag.split("=");
//                        String state4 = w00000TextFlagArray[1];
//                        state4 = state4.substring(0,1);
//                        envRealTimeEntity.setWszt(state4);
//                        //add_time
//                        envRealTimeEntity.setAddTime(new Timestamp(new Date().getTime()));
//                        envRealTimeRepo.save(envRealTimeEntity);
//                    }else  if(cn.trim().equalsIgnoreCase("2051")){
//                        //分钟采样数据
//                        System.out.println("分钟");
//                        EnvMinuteEntity envMinuteEntity = new EnvMinuteEntity();
//                        envMinuteEntity.setSt(st);
//                        envMinuteEntity.setCn(cn);
//                        //qn
//                        String qnText = receiveDataArray[0];
//                        String qn = qnText.substring(qnText.indexOf("QN=")+3,qnText.length());
//                        System.out.println("qn>>"+qn);
//                        envMinuteEntity.setQn(qn);
//                        //mn
//                        String mnText = receiveDataArray[4];
//                        String mn = mnText.substring(mnText.indexOf("MN=")+3,mnText.length());
//                        System.out.println("mn>>"+mn);
//                        envMinuteEntity.setMn(mn);
//                        //flag
////                        String flagText = receiveDataArray[5];
////                        String flag = flagText.substring(flagText.indexOf("Flag=")+5,flagText.length());
////                        System.out.println("flag>>"+flag);
//                        //datetime
//                        String datetimeText = receiveDataArray[6];
//                        String datetime = datetimeText.substring(datetimeText.indexOf("DataTime=")+9,datetimeText.length());
//                        envMinuteEntity.setDatetime(new Timestamp(dateUtil.parseDateTimeLong(dateUtil.rebuildDateTime(datetime))));
//                        //w01018
//                        String w01018Text = receiveDataArray[7];
//                        String[] w01018TextArray = w01018Text.split(",");
//                        //valueMin1
//                        String  w01018TextMin = w01018TextArray[0];
//                        String[] w01018TextMinArray = w01018TextMin.split("=");
//                        String valueMin1 = w01018TextMinArray[1];
//                        envMinuteEntity.setHxxylZx(valueMin1);
//                        //valueMin2
//                        String  w01018TextMax = w01018TextArray[1];
//                        String[] w01018TextMaxArray = w01018TextMax.split("=");
//                        String valueMax1 = w01018TextMaxArray[1];
//                        envMinuteEntity.setHxxylZd(valueMax1);
//                        //valueAvg1
//                        String  w01018TextAvg = w01018TextArray[2];
//                        String[] w01018TextAvgArray = w01018TextAvg.split("=");
//                        String valueAvg1 = w01018TextAvgArray[1];
//                        envMinuteEntity.setHxxylPj(valueAvg1);
//                        //flag1
//                        String  w01018TextFlag = w01018TextArray[4];
//                        String[] w01018TextFlagArray = w01018TextFlag.split("=");
//                        String state1 = w01018TextFlagArray[1];
//                        envMinuteEntity.setHxxylzt(state1);
//                        //w21003
//                        String w21003Text = receiveDataArray[8];
//                        String[] w21003TextArray = w21003Text.split(",");
//                        //valueMin2
//                        String  w21003TextMin = w21003TextArray[0];
//                        String[] w21003TextMinArray = w21003TextMin.split("=");
//                        String valueMin2 = w21003TextMinArray[1];
//                        envMinuteEntity.setAdZx(valueMin2);
//                        //valueMax2
//                        String  w21003TextMax = w21003TextArray[1];
//                        String[] w21003TextMaxArray = w21003TextMax.split("=");
//                        String valueMax2 = w21003TextMaxArray[1];
//                        envMinuteEntity.setAdZd(valueMax2);
//                        //valueAvg2
//                        String  w21003TextAvg = w21003TextArray[2];
//                        String[] w21003TextAvgArray = w21003TextAvg.split("=");
//                        String valueAvg2 = w21003TextAvgArray[1];
//                        envMinuteEntity.setAdPj(valueAvg2);
//                        //flag4
//                        String  w21003TextFlag = w21003TextArray[4];
//                        String[] w21003TextFlagArray = w21003TextFlag.split("=");
//                        String state2 = w21003TextFlagArray[1];
//                        envMinuteEntity.setAdzt(state2);
//                        //w01001
//                        String w01001Text = receiveDataArray[9];
//                        String[] w01001TextArray = w01001Text.split(",");
//                        //valueMin3
//                        String  w01001TextMin = w01001TextArray[0];
//                        String[] w01001TextMinArray = w01001TextMin.split("=");
//                        String valueMin3 = w01001TextMinArray[1];
//                        envMinuteEntity.setPhZx(valueMin3);
//                        //valueMax3
//                        String  w01001TextMax = w01001TextArray[1];
//                        String[] w01001TextMaxArray = w01001TextMax.split("=");
//                        String valueMax3 = w01001TextMaxArray[1];
//                        envMinuteEntity.setPhZd(valueMax3);
//                        //valueAvg3
//                        String  w01001TextAvg = w01001TextArray[2];
//                        String[] w01001TextAvgArray = w01001TextAvg.split("=");
//                        String valueAvg3 = w01001TextAvgArray[1];
//                        envMinuteEntity.setPhPj(valueAvg3);
//                        //flag3
//                        String  w01001TextFlag = w01001TextArray[3];
//                        String[] w01001TextFlagArray = w01001TextFlag.split("=");
//                        String state3 = w01001TextFlagArray[1];
//                        envMinuteEntity.setPhzt(state3);
//                        //w00000
//                        String w00000Text = receiveDataArray[10];
//                        String[] w00000TextArray = w00000Text.split(",");
//                        //valueMin4
//                        String  w00000TextMin = w00000TextArray[0];
//                        String[] w00000TextMinArray = w00000TextMin.split("=");
//                        String valueMin4 = w00000TextMinArray[1];
//                        envMinuteEntity.setWsZx(valueMin4);
//                        //valueMax4
//                        String  w00000TextMax = w00000TextArray[1];
//                        String[] w00000TextMaxArray = w00000TextMax.split("=");
//                        String valueMax4 = w00000TextMaxArray[1];
//                        envMinuteEntity.setWsZd(valueMax4);
//                        //valueAvg4
//                        String  w00000TextAvg = w00000TextArray[2];
//                        String[] w00000TextAvgArray = w00000TextAvg.split("=");
//                        String valueAvg4 = w00000TextAvgArray[1];
//                        envMinuteEntity.setWsPj(valueAvg4);
//                        //flag4
//                        String  w00000TextFlag = w00000TextArray[4];
//                        String[] w00000TextFlagArray = w00000TextFlag.split("=");
//                        String state4 = w00000TextFlagArray[1];
//                        state4 = state4.substring(0,1);
//                        envMinuteEntity.setWszt(state4);
//                        //add_time
//                        envMinuteEntity.setAddTime(new Timestamp(new Date().getTime()));
//                        EnvMinuteEntity addResult = envMinuteRepo.save(envMinuteEntity);
//                    }else  if(cn.trim().equalsIgnoreCase("2061")){
//                        //小时采样数据
//                        System.out.println("小时");
//                        EnvHourEntity envHourEntity = new EnvHourEntity();
//                        envHourEntity.setSt(st);
//                        envHourEntity.setCn(cn);
//                        //qn
//                        String qnText = receiveDataArray[0];
//                        String qn = qnText.substring(qnText.indexOf("QN=")+3,qnText.length());
//                        System.out.println("qn>>"+qn);
//                        envHourEntity.setQn(qn);
//                        //mn
//                        String mnText = receiveDataArray[4];
//                        String mn = mnText.substring(mnText.indexOf("MN=")+3,mnText.length());
//                        System.out.println("mn>>"+mn);
//                        envHourEntity.setMn(mn);
//                        //flag
////                        String flagText = receiveDataArray[5];
////                        String flag = flagText.substring(flagText.indexOf("Flag=")+5,flagText.length());
////                        System.out.println("flag>>"+flag);
//                        //datetime
//                        String datetimeText = receiveDataArray[6];
//                        String datetime = datetimeText.substring(datetimeText.indexOf("DataTime=")+9,datetimeText.length());
//                        envHourEntity.setDatetime(new Timestamp(dateUtil.parseDateTimeLong(dateUtil.rebuildDateTime(datetime))));
//                        //w01018
//                        String w01018Text = receiveDataArray[7];
//                        String[] w01018TextArray = w01018Text.split(",");
//                        //valueMin1
//                        String  w01018TextMin = w01018TextArray[0];
//                        String[] w01018TextMinArray = w01018TextMin.split("=");
//                        String valueMin1 = w01018TextMinArray[1];
//                        envHourEntity.setHxxylZx(valueMin1);
//                        //valueMin2
//                        String  w01018TextMax = w01018TextArray[1];
//                        String[] w01018TextMaxArray = w01018TextMax.split("=");
//                        String valueMax1 = w01018TextMaxArray[1];
//                        envHourEntity.setHxxylZd(valueMax1);
//                        //valueAvg1
//                        String  w01018TextAvg = w01018TextArray[2];
//                        String[] w01018TextAvgArray = w01018TextAvg.split("=");
//                        String valueAvg1 = w01018TextAvgArray[1];
//                        envHourEntity.setHxxylPj(valueAvg1);
//                        //flag1
//                        String  w01018TextFlag = w01018TextArray[4];
//                        String[] w01018TextFlagArray = w01018TextFlag.split("=");
//                        String state1 = w01018TextFlagArray[1];
//                        envHourEntity.setHxxylzt(state1);
//                        //w21003
//                        String w21003Text = receiveDataArray[8];
//                        String[] w21003TextArray = w21003Text.split(",");
//                        //valueMin2
//                        String  w21003TextMin = w21003TextArray[0];
//                        String[] w21003TextMinArray = w21003TextMin.split("=");
//                        String valueMin2 = w21003TextMinArray[1];
//                        envHourEntity.setAdZx(valueMin2);
//                        //valueMax2
//                        String  w21003TextMax = w21003TextArray[1];
//                        String[] w21003TextMaxArray = w21003TextMax.split("=");
//                        String valueMax2 = w21003TextMaxArray[1];
//                        envHourEntity.setAdZd(valueMax2);
//                        //valueAvg2
//                        String  w21003TextAvg = w21003TextArray[2];
//                        String[] w21003TextAvgArray = w21003TextAvg.split("=");
//                        String valueAvg2 = w21003TextAvgArray[1];
//                        envHourEntity.setAdPj(valueAvg2);
//                        //flag4
//                        String  w21003TextFlag = w21003TextArray[4];
//                        String[] w21003TextFlagArray = w21003TextFlag.split("=");
//                        String state2 = w21003TextFlagArray[1];
//                        envHourEntity.setAdzt(state2);
//                        //w01001
//                        String w01001Text = receiveDataArray[9];
//                        String[] w01001TextArray = w01001Text.split(",");
//                        //valueMin3
//                        String  w01001TextMin = w01001TextArray[0];
//                        String[] w01001TextMinArray = w01001TextMin.split("=");
//                        String valueMin3 = w01001TextMinArray[1];
//                        envHourEntity.setPhZx(valueMin3);
//                        //valueMax3
//                        String  w01001TextMax = w01001TextArray[1];
//                        String[] w01001TextMaxArray = w01001TextMax.split("=");
//                        String valueMax3 = w01001TextMaxArray[1];
//                        envHourEntity.setPhZd(valueMax3);
//                        //valueAvg3
//                        String  w01001TextAvg = w01001TextArray[2];
//                        String[] w01001TextAvgArray = w01001TextAvg.split("=");
//                        String valueAvg3 = w01001TextAvgArray[1];
//                        envHourEntity.setPhPj(valueAvg3);
//                        //flag3
//                        String  w01001TextFlag = w01001TextArray[3];
//                        String[] w01001TextFlagArray = w01001TextFlag.split("=");
//                        String state3 = w01001TextFlagArray[1];
//                        envHourEntity.setPhzt(state3);
//                        //w00000
//                        String w00000Text = receiveDataArray[10];
//                        String[] w00000TextArray = w00000Text.split(",");
//                        //valueMin4
//                        String  w00000TextMin = w00000TextArray[0];
//                        String[] w00000TextMinArray = w00000TextMin.split("=");
//                        String valueMin4 = w00000TextMinArray[1];
//                        envHourEntity.setWsZx(valueMin4);
//                        //valueMax4
//                        String  w00000TextMax = w00000TextArray[1];
//                        String[] w00000TextMaxArray = w00000TextMax.split("=");
//                        String valueMax4 = w00000TextMaxArray[1];
//                        envHourEntity.setWsZd(valueMax4);
//                        //valueAvg4
//                        String  w00000TextAvg = w00000TextArray[2];
//                        String[] w00000TextAvgArray = w00000TextAvg.split("=");
//                        String valueAvg4 = w00000TextAvgArray[1];
//                        envHourEntity.setWsPj(valueAvg4);
//                        //flag4
//                        String  w00000TextFlag = w00000TextArray[4];
//                        String[] w00000TextFlagArray = w00000TextFlag.split("=");
//                        String state4 = w00000TextFlagArray[1];
//                        state4 = state4.substring(0,1);
//                        envHourEntity.setWszt(state4);
//                        //add_time
//                        envHourEntity.setAddTime(new Timestamp(new Date().getTime()));
//                        envHourRepo.save(envHourEntity);
//                    }else  if(cn.trim().equalsIgnoreCase("2031")){
//                        //日采样历史数据
//                        System.out.println("日采样历史数据不处理!");
//                    }else{
//                        System.out.println("其他数据不处理!");
//                    }
//                }else{
//                }
//            }else{
//                System.out.println("该数据非污染物实时采样数据");
//            }
//        }
//    }
}
